﻿ // Churn algorithm to solve Incomplete Columnar.
 // Includes calculation of factor for long or short ciphers.
 // by Michael J. Cowan 2008 - 2009.


 #include <iostream>
 #include <condefs.h>
 #include <conio.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <fstream.h>


 char codex[1000],code[1000], plain[1000], crib[20],decode[1000],grid[60][60];

 int flag,noc,nor,nok;
 int j,k,m,n,p,q,t,x,y,z;
 int ass[60];
 int first,second,third,fourth,score,maxscore,bestscore;
 int best[50],maxi[50],buff;
 int len,len_col[40],len_short_col,len_long_col,nr_long_col,good,mike,calc;
 short a[26][26][26][26];
 float factor, leng;

          //....this is Churn data for ciphers of length 100 to 120 letters....
 int value[1000] = {0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,2,2,2,2,2,3,3,3,3,4,4,4,4,4,4,4,5,5,5,5,5,6,6,6,
    6,6,7,7,8,8,8,8,9,9,9,9,9,10,10,10,10,11,11,11,11,12,12,13,13,14,14,15,15,15,15,
    16,16,17,17,18,18,19,20,20,21,22,22,23,24,25,26,27,28,29,30,32,33,36,38,40,42,47,56};


 FILE *InFile;

 void randomise_ass_order(void);
 void make_grid(void);
 void decrypt(void);
 void tetragraphs(void);
 void get_score(void);


 main()

 {

  strcpy(codex,"SECER ISEAS DTLAE HERHL JTSSH FWRTF LHASR EIPMM OMLAS ETNSO HEDSI EDOHO RENHD LAENT STTPO REAME KHRTD ATCVN ATHLP TTPAI WOAPI NEOEE SHITI ITBAT NFEST ANTES TCRFI OINAO ADNTU LEOUS SIFRO NDIOW BSIES TEUEO AHSSF GEESS GAHTH HOTAO BIBHW TEAIE SHTHA TEDIU NGIRE SOESU ITUTE BDHTS ORLFN ABTLE SAUYM SOORA");



  len=strlen(codex); t=-1;
  for(j=0;j<len;j++)
    if(codex[j]>64) { t++; code[t]=codex[j]; }
  len=strlen(code);

  leng=len; factor=110/leng;

  cout<<"length="<<len<<"  factor="<<factor<<endl;


    for(m=0;m<len;m++) cout<<code[m]; cout<<endl;
    randomize();


   InFile = fopen( "TetraLog_hank.bin", "rb" );


  fread( a, 2, 456976, InFile );  // read 456976 values, 2 bytes per value, into array a[][][][] from InFile
  fclose( InFile );
  cout<<"Hank's tetragraphs loaded...."<<endl;


  noc=20;

    len_short_col=len/noc;
    len_long_col=len_short_col+1;
    nr_long_col=len%noc;
    for(m=0;m<nr_long_col;m++) len_col[m]=len_long_col;
    for(m=nr_long_col;m<noc;m++) len_col[m]=len_short_col;


    nor=len_long_col;
    cout<<"noc="<<noc<<" nor="<<nor<<endl;

    mike=1; bestscore=0;
    do{
       
       score=maxscore=0;
       randomise_ass_order();
       make_grid();
       decrypt();
       get_score();
       maxscore=score;

       do   //exchange
         {
          good=0;
          for(p=0;p<noc-1;p++)
            for(q=p+1;q<noc;q++)
            {


               buff=ass[p]; ass[p]=ass[q]; ass[q]=buff;
               make_grid(); decrypt(); get_score();
               calc= value[random(100)];
               if(score>maxscore - calc)
                {
                 maxscore=score;
                 for(m=0;m<noc;m++) maxi[m]=ass[m];
                 good=1;
                }
              else
               {
                buff=ass[p]; ass[p]=ass[q]; ass[q]=buff;
               }

            }
         }while(good>0);

    }while(mike>0);


 cout<<endl<<"end";
 getch();

 return 0;
 }

//---------------------------------------------------------




void randomise_ass_order(void)

 {
  flag=0;
  for(j=0;j<noc;j++)
    ass[j]=99;


   for(j=0;j<noc;j++)
     {
       x=random(noc);       // random #s 0 to 9

       for (k=0;k<noc;k++)
           if (ass[k]==x)
             flag=1;
        if (flag==1)
           {j--;
            flag=0;
            }
        else
         ass[j]=x;
     }//end for

 }






 void make_grid(void)
 {
    int row,col,p,t;

    t=-1;
    for(p=0;p<noc;p++)
      {
       col=ass[p];
       for(row=0;row<len_col[col];row++)  //
         {
          t++;grid[row][col]=code[t];
         }
      }
 }



 void decrypt(void)
 {
    int row,col,t;

    row=0;col=-1;t=-1;
    while(t<len-1)
      {
       col++;
       if(col==noc) {col=0;row++;}
       t++; decode[t]=grid[row][col];
      }

 }


  void get_score(void)
  {
    int p,q;
    char primus;

     score=0; nok++;

     for(p=0;p<len-4;p++)
         {first=decode[p]-65;
          second=decode[p+1]-65;
          third=decode[p+2]-65;
          fourth=decode[p+3]-65;
          score=score+a[first][second][third][fourth];
          }

      score=score*factor;

      if(score>bestscore)

             {
              bestscore=score;
              cout<<"nok="<<nok<<"  score="<<bestscore<<endl;
              cout<<"assembly order= ";
              for(p=0;p<noc;p++) cout<<ass[p]<<" "; cout<<endl;
              cout<<"report key= ";
              for(p=0;p<noc;p++)
               for(q=0;q<noc;q++)
                if(p==ass[q]) {cout<<q+1<<" "; break; }
              cout<<endl;
              for(p=0;p<len;p++)
                {primus=decode[p]+32; cout<<primus;}
              cout<<endl<<endl;

             }


  }






